<script lang="ts">
  import clickOutside from '@svelte-common/hooks/useClickOutside.js';
  import { createEventDispatcher } from 'svelte';

  export let options: Record<string, string>[] = [];
  export let selected = 0;
  export let active: boolean = false;

  const dispatch = createEventDispatcher();
  $: dispatch('toggle', { active });

  const onClickOutside = () => {
    active = false;
  };

  const onClickSelect = (event: Event) => {
    active = !active;
  };

  const onSelect = (id: number) => {
    active = false;
    selected = id;
  };
</script>

<div class="dropdown" use:clickOutside={onClickOutside}>
  <button class="selected" on:click={onClickSelect}>{options[selected].opt}</button>
  <slot name="options">
    <div class="options" class:open={active} class:close={!active}>
      {#each options as option (option.id)}
        <button class="option" on:click={onSelect.bind(null, option.id)}>
          <img src={option.icon} />{option.opt}</button
        >
      {/each}
    </div></slot
  >
</div>

<style>
  .dropdown {
    width: 100%;
  }

  .selected {
    width: 100%;
  }

  .options {
    position: absolute;
    display: flex;
    flex-direction: column;
    pointer-events: none; /* Disable interactions when hidden */
  }

  .options > .option {
    padding: 5px 10px;
  }

  .open {
    opacity: 1;
    pointer-events: auto; /* Enable interactions when open */
  }

  .close {
    opacity: 0;
  }
</style>
